import os
import sys
import argparse

parser = argparse.ArgumentParser()
parser.add_argument("source", help="source foldername")
parser.add_argument("-o", "--output", help="output filename")
args = parser.parse_args()

index = bytearray()
files = bytearray()
indexcount = 0

foldermain = args.source
fileout = args.output
foldermain = foldermain.lower()

if fileout is None:
    fileout = foldermain+".gpak"

def int_to_bytes(val, num_bytes):
    return [(val & (0xff << pos*8)) >> pos*8 for pos in range(num_bytes)]

for dirName, subdirList, fileList in os.walk(foldermain):
    for fname in fileList:
        indexcount = indexcount+1
        fullPath = dirName+"\\"+fname
        
        fullPath = fullPath.replace('\\', '/')
        fullPath = fullPath.lower()

        if fullPath.startswith(foldermain):
            keyPath = fullPath[len(foldermain)+1:]

        index.extend(int_to_bytes(len(keyPath),2))
        index.extend(bytearray(keyPath, "ascii"))
        with open(fullPath, mode='rb') as file:
            fileContent = file.read()
            length = len(fileContent)
            
            print("Packing "+keyPath + " ("+str(length)+" bytes)")
            index.extend(int_to_bytes(length,4))
            
            files.extend(fileContent)


outfile = open(fileout, "wb")
outfile.write(bytearray(int_to_bytes(indexcount,4)))
outfile.write(index)
outfile.write(files)
